rollout helptools "Help Tools"
(
	group "Objects"
	(
		button scnhndlr "Auto Handler" across:2 width:84 height:16 align:#left
		button scnhndlrinfo "i" width:12 height:16 align:#right
		button rndmcol "Random Color" across:2 width:84 height:16 align:#left
		button rndmcolinfo "i" width:12 height:16 align:#right
		button cnvpoly "Convert to Poly" across:2 width:84 height:16 align:#left
		button cnvpolyinfo "i" width:12 height:16 align:#right
		button evrem "Rem. Edge/Vert" across:2 width:84 height:16 align:#left
		button evreminfo "i" width:12 height:16 align:#right
		button massimp "Mass Import" across:3 width:70 height:16 align:#left
		button massimpedit "e" offset:[29,0] width:12 height:16 align:#center
		button massimpinfo "i" offset:[-1,0] width:12 height:16 align:#right
		button ddf_pz "Del Doubl Face" across:2 width:84 height:16 align:#left
		button ddf_pzinfo "i" width:12 height:16 align:#right enabled:false
		button objsm "Smooth" across:2 width:52 height:16 align:#left
		spinner spin_objsm "" range:[20,180,60] width:43 height:16 scale:10 type:#integer align:#right offset:[0,0]
		--button ddf_pzinfo "i" width:12 height:16 align:#right enabled:false
	)
	--BUTTON "RANDOM COLOR"
	on rndmcol pressed do 
	(
		for obj in selection do
			(
				obj.wirecolor = color (random 0 255) (random 0 255) (random 0 255)
			)
	)
	--BUTTON "RANDOM COLOR INFO"
	on rndmcolinfo pressed do 
	(
		clearlistener()
		completeredraw()
				
		gw.hMarker (point3 22 208 0) #smallDiamond color:green
		gw.hText (point3 27 200 0) "Makes different color for selected objects" color:green
		gw.hText (point3 20 182 0) "- before using this make sure you have any object selected" color:yellow
		gw.hText (point3 20 168 0) "- this message will disappear after any action in viewport" color:yellow
		gw.enlargeUpdateRect #whole 
		gw.updateScreen()
	)
	--BUTTON "CONVERT TO POLY"	
	on cnvpoly pressed do
	(
		for obj in selection do
			(
			macros.run "Modifier Stack" "Convert_to_Poly"
			)
	)
	--BUTTON "CONVERT TO POLY INFO"
	on cnvpolyinfo pressed do 
	(
		clearlistener()
		completeredraw()
		
		gw.hMarker (point3 22 208 0) #smallDiamond color:green
		gw.hText (point3 27 200 0) "Simple convert to poly selected objects in one click" color:green
		gw.hText (point3 20 182 0) "- before using this make sure you have any object selected" color:yellow
		gw.hText (point3 20 168 0) "- this message will disappear after any action in viewport" color:yellow
		gw.enlargeUpdateRect #whole 
		gw.updateScreen()
	)
	--BUTTON "EDGE/VERTEX REMOVER"
	on evrem pressed do
	(
		for obj in selection do
		(
			macros.run "Editable Polygon Object" "EPoly_Convert_Sel_To_Vertex"
			subobjectLevel = 2
			$.EditablePoly.Remove ()
			subobjectLevel = 1
			$.EditablePoly.Remove ()
			subobjectLevel = 2
		)
	)
	--BUTTON "EDGE/VERTEX REMOVER INFO"
	on evreminfo pressed do 
	(
		clearlistener()
		completeredraw()
		
		gw.hMarker (point3 22 208 0) #smallDiamond color:green
		gw.hText (point3 27 200 0) "Removes selected vertex and facing close edges" color:green
		gw.hText (point3 20 182 0) "- your object must be Editable Poly" color:yellow
		gw.hText (point3 20 168 0) "- this message will disappear after any action in viewport" color:yellow
		gw.enlargeUpdateRect #whole 
		gw.updateScreen()
	)
	--BUTTON "MASS IMPORT"		
	on massimp pressed do
	(
		try (fileIn (scriptspath+"\\tswscripts\\mass-import.ms") quiet:true   )
            catch messagebox "Please choose directory with your obj files!" \
			title:"You didn't choose anything"
	)
	--BUTTON "MASS IMPORT INFO"
	on massimpinfo pressed do 
	(
		clearlistener()
		completeredraw()
		
		gw.hMarker (point3 22 208 0) #smallDiamond color:green
		gw.hText (point3 27 200 0) "This function imports mass of files into curent scene" color:green
		gw.hText (point3 20 182 0) "- before using this you need to edit mass-import.ms with your settings" color:yellow
		gw.hText (point3 20 168 0) "- you can use ''print importerPlugin.classes'' command to see what formats 3ds max support" color:yellow
		gw.hText (point3 20 154 0) "- this message will disappear after any action in viewport" color:yellow
		gw.enlargeUpdateRect #whole 
		gw.updateScreen()
	)
		--BUTTON "MASS IMPORT EDIT"		
	on massimpedit pressed do
	(
		scriptfile=(scriptspath+"\\tswbase\\mass-import.ms")
		edit scriptfile
	)
	--BUTTON "AUTO HANDLER"	
	on scnhndlr pressed do
	(
		clearlistener()
		max select all
		
		CenterPivot objects
		resetxform $
 		convertTo $ TriMeshGeometry

		$.backfacecull = on
	
		a = viewport.GetFOV()
		a = 30
		viewport.SetFOV a
		completeredraw()
		print a

		completeredraw()
		
		deselect $

	)
	--BUTTON "AUTO HANDLER INFO"
	on scnhndlrinfo pressed do 
	(
		clearlistener()
		completeredraw()
		
		gw.hMarker (point3 22 208 0) #smallDiamond color:green
		gw.hText (point3 27 200 0) "This function include several modification of your scene:" color:green
		gw.hText (point3 20 182 0) "- before using this you don't need to select any objects" color:yellow
		gw.hText (point3 20 168 0) "- converts pivot to all objects" color:yellow
		gw.hText (point3 20 154 0) "- reseting xform of all objects" color:yellow
		gw.hText (point3 20 140 0) "- converts all objects into Editable Poly" color:yellow
		gw.hText (point3 20 126 0) "- backface culling set in ON" color:yellow
		gw.hText (point3 20 112 0) "- viewport FOV set in 30" color:yellow
		gw.hText (point3 20 98 0) "- this message will disappear after any action in viewport" color:yellow
		gw.enlargeUpdateRect #whole 
		gw.updateScreen()
	)
	
	--BUTTON "DELETE DOUBLE FACES"			
	on ddf_pz pressed do
	(
		(try (fileIn (scriptspath+"\\tswscripts\\ddf41_pz.ms") quiet:true   )
            catch messagebox "" \
			title:"Can't find script"
		)
	)

	--BUTTON "SMOOTH"
	on objsm pressed do
	(
		max create mode
		
		threshaver=spin_objsm.value
		sm = SmoothModifier autoSmooth:true threshold:spin_objsm.value
		for o in geometry do addModifier o sm
		
		max select all
		
		for obj in selection do
			(
				convertTo $ TriMeshGeometry
			)
			
		max modify mode
		max select none
	)
	
	group "Materials"
	(
		button rndruv "UV" across:3 width:28 height:16 align:#left
		spinner rndruvsize "" range:[256,4096,1024] type:#integer width:54 height:16 scale:256 align:#center offset:[8,0]
		button rndruvinfo "i" width:12 height:16 align:#right
		button usedmap "Used Maps" across:2 width:84 height:16 align:#left
		button usedmapinfo "i" width:12 height:16 align:#right
		button uvrepar "UV Repair" across:2 width:84 height:16 align:#left
		button uvreparinfo "i" width:12 height:16 align:#right
	)
	--BUTTON "RENDER UV"		
	on rndruv pressed do
	(
		for obj in selection do
		(
			clearlistener()
			max modify mode

			modPanel.addModToSelection (Unwrap_UVW ()) ui:off
			$.modifiers[#Unwrap_UVW].renderuv_fillmode = 1
			$.modifiers[#Unwrap_UVW].renderuv_width = rndruvsize.value
			$.modifiers[#Unwrap_UVW].renderuv_height = rndruvsize.value
			$.modifiers[#Unwrap_UVW].renderuv_showoverlap = true
			$.modifiers[#Unwrap_UVW].renderUV "uv.png"
			
			subobjectLevel = 0
			deleteModifier $ 1
		)
	)
	--BUTTON "RENDER UV INFO"
	on rndruvinfo pressed do 
	(
		clearlistener()
		completeredraw()
		
		gw.hMarker (point3 22 208 0) #smallDiamond color:green
		gw.hText (point3 27 200 0) "Renders UV map of channel 1" color:green
		gw.hText (point3 20 182 0) "- before useing this you need to select any object" color:yellow
		gw.hText (point3 20 168 0) "- after activating on selected object modifier ''Unwrap UVW'' will be added" color:yellow
		gw.hText (point3 20 154 0) "- and ''Render UVW Template'' will render texture map 1024x1024" color:yellow
		gw.enlargeUpdateRect #whole 
		gw.updateScreen()
	)
	--BUTTON "USED MAPS"			
	on usedmap pressed do
	(
		clearlistener()
		completeredraw()
		
		ma = usedmaps()
		for i in 1 to ma.count do ( 
		gw.wText [10,50+(i*15),0] ma[i] color:yellow
		)
		gw.enlargeUpdateRect #whole 
		gw.updateScreen()
	)	
	--BUTTON "USED MAPS INFO"
	on usedmapinfo pressed do 
	(
		clearlistener()
		completeredraw()
		
		gw.hMarker (point3 22 208 0) #smallDiamond color:green
		gw.hText (point3 27 200 0) "Simple shows:" color:green
		gw.hText (point3 20 182 0) "- image files used in this scene" color:yellow
		gw.hText (point3 20 168 0) "- hdri files used in this scene" color:yellow
		gw.hText (point3 20 154 0) "- path to each image file used in this scene (also for hdri files)" color:yellow
		gw.enlargeUpdateRect #whole 
		gw.updateScreen()
	)

	--BUTTON "UV REPAIR"			
	on uvrepar pressed do
	(
		(try (fileIn (scriptspath+"\\tswscripts\\uv-repair-tools.ms") quiet:true   )
            catch messagebox "" \
			title:"Can't find script"
		)
	)	
	--BUTTON "UV REPAIR INFO"
	on uvreparinfo pressed do 
	(
		clearlistener()
		completeredraw()
		
		gw.hMarker (point3 22 208 0) #smallDiamond color:green
		gw.hText (point3 27 200 0) "Additional Tool:" color:green
		gw.hText (point3 20 182 0) "- repairing uv coordinates for 3dr files (3d ripper)" color:yellow
		gw.enlargeUpdateRect #whole 
		gw.updateScreen()
	)
	

group "Scene"
	(
		button butfov "Set FOV" across:2 width:48 height:16 align:#left
		spinner spinfov "" range:[15,360,30] width:48 height:16 type:#integer scale:15 align:#right
		button butamb "Ambient" across:2 width:48 height:16 align:#left
		spinner spinamb "" range:[0,255,100] width:48 height:16 type:#integer scale:50 align:#right
		button butscl "Sclale %" across:2 width:48 height:16 align:#left
		spinner spinscl "" range:[0,100000,1000] width:48 height:16 type:#integer scale:9000 align:#right
		
	)
	
	on butfov pressed do
	(
		a = viewport.GetFOV()
		a = spinfov.value
		viewport.SetFOV a
		completeredraw()
		--print a
	)
		
	on butamb pressed do
	(
		--abmset = ambientColor ()
		abmsetR = spinamb.value
		abmsetG = spinamb.value
		abmsetB = spinamb.value
		ambientColor = color abmsetR abmsetG abmsetB
		completeredraw()
	)
	
	on butscl pressed do
	(
		clearlistener()
		
		scaleX = spinscl.value/100
		scaleY = spinscl.value/100
		scaleZ = spinscl.value/100
		
		scale $ [scaleX,scaleY,scaleZ]
		
		completeredraw()
		deselect $
		max tool zoomextents all
	)

)

	-------------------------------------------------------------------------
	--UV TOOLS rolout block
	-------------------------------------------------------------------------

rollout uvtool "UV Repair Tools"
(
	
	button getpuv "Prototype (7)" width:98 height:16 align:#center
	
	on getpuv pressed do 
	(
		for obj in selection do
			(
			
			srcUV = 7
			destUV = 1

			try (
					channelinfo.copychannel obj 3 srcUV
					channelinfo.pastechannel obj 3 destUV
					channelinfo.clearchannel obj srcUV
			)
			catch()

			maps = getClassInstances bitmaptexture 
			for m in maps where m.coords.mapChannel == srcUV do (m.coords.mapChannel = destUV)
			
			macros.run "Modifier Stack" "Convert_to_Poly"
			)
		
	)
	
	button maf2uv "Mafia 2 (2)" width:98 height:16 align:#center
	
	on maf2uv pressed do 
	(
		for obj in selection do
			(
			
			srcUV = 2
			destUV = 1

			try (
					channelinfo.copychannel obj 3 srcUV
					channelinfo.pastechannel obj 3 destUV
					channelinfo.clearchannel obj srcUV
			)
			catch()

			maps = getClassInstances bitmaptexture 
			for m in maps where m.coords.mapChannel == srcUV do (m.coords.mapChannel = destUV)
			
			macros.run "Modifier Stack" "Convert_to_Poly"
			)
		
	)
	
	button codbouv "COD: BO (6)" width:98 height:16 align:#center
	
	on codbouv pressed do 
	(
		for obj in selection do
			(
			
			srcUV = 6
			destUV = 1

			try (
					channelinfo.copychannel obj 3 srcUV
					channelinfo.pastechannel obj 3 destUV
					channelinfo.clearchannel obj srcUV
			)
			catch()

			maps = getClassInstances bitmaptexture 
			for m in maps where m.coords.mapChannel == srcUV do (m.coords.mapChannel = destUV)
			
			macros.run "Modifier Stack" "Convert_to_Poly"
			)
		
	)
		
	
	button wmenuv4 "Watchmen (4)" width:98 height:16 align:#center
	
	on wmenuv4 pressed do 
	(
		for obj in selection do
			(
			
			srcUV = 4
			destUV = 1

			try (
					channelinfo.copychannel obj 3 srcUV
					channelinfo.pastechannel obj 3 destUV
					channelinfo.clearchannel obj srcUV
			)
			catch()

			maps = getClassInstances bitmaptexture 
			for m in maps where m.coords.mapChannel == srcUV do (m.coords.mapChannel = destUV)
			
			macros.run "Modifier Stack" "Convert_to_Poly"
			)
		
	)
	
	button wmenuv3 "Watchmen (3)" width:98 height:16 align:#center
	
	on wmenuv3 pressed do 
	(
		for obj in selection do
			(
			
			srcUV = 3
			destUV = 1

			try (
					channelinfo.copychannel obj 3 srcUV
					channelinfo.pastechannel obj 3 destUV
					channelinfo.clearchannel obj srcUV
			)
			catch()

			maps = getClassInstances bitmaptexture 
			for m in maps where m.coords.mapChannel == srcUV do (m.coords.mapChannel = destUV)
			
			macros.run "Modifier Stack" "Convert_to_Poly"
			)
		
	)
)


rof=newrolloutfloater "tswscripts" 138 100 35 0

addrollout helptools rof

rof.size=[138,390]